"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../components/Styles/theme");
const Touchable_1 = __importDefault(require("../Touchable"));
const Button = props => {
    const { style, type = 'default', disabled = false, onPress, children } = props;
    const themeStyle = {
        default: styles.default,
        primary: styles.primary,
        warning: styles.warning,
        success: styles.success,
        danger: styles.danger,
    };
    const underlayColor = {
        default: theme_1.Theme.fillBody,
        primary: theme_1.Theme.brandPrimaryTap,
        warning: theme_1.Theme.brandWarningTap,
        success: theme_1.Theme.brandSuccessTap,
        danger: theme_1.Theme.brandErrorTap,
    };
    return (react_1.default.createElement(Touchable_1.default, { style: [styles.container, themeStyle[type], disabled && styles.disabled, style], underlayColor: underlayColor[type], onPress: disabled ? undefined : onPress },
        react_1.default.createElement(react_native_1.Text, { style: [styles.text, type !== 'default' && styles.textWhite] }, children)));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        alignItems: 'center',
        justifyContent: 'center',
        height: theme_1.Theme.buttonHeight,
        borderRadius: 4,
    },
    primary: {
        backgroundColor: theme_1.Theme.brandPrimary,
    },
    default: {
        backgroundColor: theme_1.Theme.fillBase,
        borderWidth: 0.5,
        borderColor: theme_1.Theme.borderColor,
    },
    danger: {
        backgroundColor: theme_1.Theme.brandError,
    },
    warning: {
        backgroundColor: theme_1.Theme.brandWarning,
    },
    success: {
        backgroundColor: theme_1.Theme.brandSuccess,
    },
    disabled: {
        opacity: 0.5,
    },
    text: {
        color: theme_1.Theme.colorTextBase,
        fontSize: theme_1.Theme.buttonFontSize,
    },
    textWhite: {
        color: theme_1.Theme.colorTextBaseInverse,
    },
});
exports.default = Button;
