"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const dayjs_1 = __importDefault(require("dayjs"));
const _1 = __importDefault(require("."));
const MONTH_LIST = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
const DatePicker = props => {
    const { visible = false, yearRange, initialDate, onClose, onConfirm } = props;
    const [startYear, endYear] = yearRange;
    const [yearList, setYearList] = react_1.useState([]);
    const [monthList, setMonthList] = react_1.useState([]);
    const [dayList, setDayList] = react_1.useState([]);
    const [selectedIndex, setSelectIndex] = react_1.useState([0, 0, 0]);
    react_1.useEffect(() => {
        const yl = [];
        for (let i = startYear; i <= endYear; i++) {
            yl.push(i);
        }
        const date = dayjs_1.default(initialDate);
        const year = date.year();
        const month = date.month() + 1;
        const day = date.date();
        const dl = getDayRange(year, month);
        setYearList(yl);
        setMonthList(MONTH_LIST);
        setDayList(dl);
        setSelectIndex([
            yl.findIndex(i => i === year),
            MONTH_LIST.findIndex(i => i === month),
            dl.findIndex(i => i === day),
        ]);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const getDayRange = (year, month) => {
        const date = dayjs_1.default(`${year}/${month}/01`).endOf('M').date();
        const dl = [];
        for (let i = 1; i <= date; i++) {
            dl.push(i);
        }
        return dl;
    };
    return (react_1.default.createElement(_1.default, { closeOnClickOverlay: true, visible: visible, barStyle: "light-content", dataSource: [
            yearList.map(i => `${i}年`),
            monthList.map(i => (i < 10 ? `0${i}月` : `${i}月`)),
            dayList.map(i => (i < 10 ? `0${i}日` : `${i}日`)),
        ], selectedIndex: selectedIndex, onClose: onClose, onChange: ([yi, mi, di]) => {
            const [y, m] = selectedIndex;
            let nd = di;
            // 改变年月才修改日期天数
            if (yi !== y || mi !== m) {
                const range = getDayRange(yearList[yi], monthList[mi]);
                if (range.length !== dayList.length) {
                    setDayList(range);
                    // 只有当月无该日期才修改
                    if (nd >= range.length) {
                        nd = 0;
                    }
                }
            }
            setSelectIndex([yi, mi, nd]);
        }, onConfirm: ([yi, mi, di]) => {
            onConfirm && onConfirm(dayjs_1.default(`${yearList[yi]}/${monthList[mi]}/${dayList[di]}`).valueOf());
        } }));
};
exports.default = DatePicker;
